commit b1a901a54e33155ac5fef3b70035696974a7ba09
Author: Lukáš Ščurko <scurkol@students.zcu.cz>
Date:   Mon Apr 22 10:54:17 2019 +0200

    Zpracování dat (metoda processData ve třídách Recordy) a přiřazení tříd/metod k jednotlivým issue (Re #7319)

diff --git a/src/data/BitmapBuilder.java b/src/data/BitmapBuilder.java
index d2caa0c..ab0800b 100644
--- a/src/data/BitmapBuilder.java
+++ b/src/data/BitmapBuilder.java
@@ -6,9 +6,13 @@ import java.util.ArrayList;
 public class BitmapBuilder {
 
     ArrayList<JDFPevnykodRecord> pevnykod = new ArrayList<>();
+    ArrayList<JDFCaskodyRecord> caskody = new ArrayList<>();
+    ArrayList<JDFSpojeRecord> spoje = new ArrayList<>();
+
     /**
      *
      * hlavni metoda pro ozkouseni funkcnosti {@code BitmapBuilder}
+     *-issue #7314
      *
      * @param args parametry programu
      */
@@ -23,6 +27,13 @@ public class BitmapBuilder {
         loadedData = loader.loadData("Pevnykod.txt");
         bitmapBuilder.getPevnyKod(loadedData);
 
+        loadedData.clear();
+        loadedData = loader.loadData("Caskody.txt");
+        bitmapBuilder.getCaskody(loadedData);
+
+        loadedData.clear();
+        loadedData = loader.loadData("Spoje.txt");
+        bitmapBuilder.getSpoje(loadedData);
         System.out.println("Ukončuji program..");
     }
 
@@ -34,4 +45,20 @@ public class BitmapBuilder {
         }
     }
 
+    public void getCaskody(ArrayList<String[]> loadedData){
+        JDFCaskodyRecord caskodyRecord;
+        for(String[] record : loadedData){
+            caskodyRecord = new JDFCaskodyRecord(record);
+            caskody.add(caskodyRecord);
+        }
+    }
+
+    public void getSpoje(ArrayList<String[]> loadedData){
+        JDFSpojeRecord spojeRecord;
+        for(String[] record : loadedData){
+            spojeRecord = new JDFSpojeRecord(record);
+            spoje.add(spojeRecord);
+        }
+    }
+
 }
diff --git a/src/data/DataLoader.java b/src/data/DataLoader.java
index 76c00b4..85834a1 100644
--- a/src/data/DataLoader.java
+++ b/src/data/DataLoader.java
@@ -6,7 +6,7 @@ import java.util.ArrayList;
 /**
  *
  * Třída pro základní čtení a parsovani zdrojových souborů
- *
+ * - issue #7315
  * @author Daniel Stus, Marek Sobota, Lukas Scurko, Jan Jirman
  * @version 1.0
  */
diff --git a/src/data/DataReader.java b/src/data/DataReader.java
index 28b653a..146fe34 100644
--- a/src/data/DataReader.java
+++ b/src/data/DataReader.java
@@ -11,6 +11,7 @@ import java.util.List;
  *
  * Zaklady cteni a parsovani zdrojovych souboru
  * cteni celeho souboru, podle linek, nacteni uzivatelskeho seznamu linek pro generovani
+ * -issue #7240
  *
  * @author Daniel Stus, Marek Sobota, Lukas Scurko, Jan Jirman
  * @version 1.0
diff --git a/src/data/IProcessable.java b/src/data/IProcessable.java
index f7c2a4a..1ce90d7 100644
--- a/src/data/IProcessable.java
+++ b/src/data/IProcessable.java
@@ -3,7 +3,7 @@ package data;
 /**
  *
  * Rozhraní pro zpracování dat - každá třída Record se jinak zpracovává, ale je potřeba metody proccesData
- *
+ * - issue #7315
  * @author Daniel Stus, Marek Sobota, Lukas Scurko, Jan Jirman
  * @version 1.0
  */
diff --git a/src/data/JDFCaskodyRecord.java b/src/data/JDFCaskodyRecord.java
index 8e626d8..ca34fc5 100644
--- a/src/data/JDFCaskodyRecord.java
+++ b/src/data/JDFCaskodyRecord.java
@@ -3,21 +3,137 @@ package data;
 /**
  *
  * Třída JDFCaskodyRecord obsahuje jeden záznam načtených dat z Caskody.txt
- *
+ *-issue #7315
  * @author Daniel Stus, Marek Sobota, Lukas Scurko, Jan Jirman
  * @version 1.0
  */
 public class JDFCaskodyRecord implements IProcessable {
 
+    //-------------- Konstanty -------------//
+
+    /** konstanta indexu: numberLine */
+    private final int numberLineIndex = 0;
+    /** konstanta indexu: numberJoin */
+    private final int numberJoinIndex = 1;
+    /** konstanta indexu: numberTimeCode */
+    private final int numberTimeCodeIndex = 2;
+    /** konstanta indexu: timeCode */
+    private final int timeCodeIndex = 3 ;
+    /** konstanta indexu: typeTimeCode */
+    private final int typeTimeCodeIndex = 4;
+    /** konstanta indexu: startDate */
+    private final int startDateIndex = 5;
+    /** konstanta indexu: endDate */
+    private final int endDateIndex = 6;
+
     //-------------- Atributy --------------/
-    //TODO vytvořit proměnné pro všechna potřebná data
+    private String numberLine;
+    private String numberJoin;
+    private String numberTimeCode;
+    private String timeCode;
+    private String typeTimeCode;
+    private String startDate;
+    private String endDate;
+
+    //-------------- Konstruktor -------------/
+
+    /**
+     * Konstruktor JDFCaskodyRecord, který vytvoří jeden záznam z caskody v JDF
+     * @param dataRecord jeden záznam načtených dat
+     */
+    public JDFCaskodyRecord(String[] dataRecord){
+        proccesData(dataRecord);
+    }
+
+    //----------------- Metody ----------------/
+
+    /**
+     * Metoda vrátí cislo linky
+     * @return cislo linky
+     */
+    public String getNumberLine() {
+        return numberLine;
+    }
+
+    /**
+     * Metoda vrátí cislo spoje
+     * @return cislo spoje
+     */
+    public String getNumberJoin() {
+        return numberJoin;
+    }
+
+    /**
+     * Metoda vrátí cislo casoveho kodu
+     * @return cislo casoveho kodu
+     */
+    public String getNumberTimeCode() {
+        return numberTimeCode;
+    }
+
+    /**
+     * Metoda vrátí casovy kod
+     * @return casovy kod
+     */
+    public String getTimeCode() {
+        return timeCode;
+    }
+
+    /**
+     * Metoda vrátí typ casoveho kodu
+     * @return typ casoveho kodu
+     */
+    public String getTypeTimeCode() {
+        return typeTimeCode;
+    }
+
+    /**
+     * Metoda vrátí datum zacatku platnosti
+     * @return datum zacatku platnosti
+     */
+    public String getStartDate() {
+        return startDate;
+    }
+
+    /**
+     * Metoda vrátí datum konce platnosti
+     * @return datum konce platnosti
+     */
+    public String getEndDate() {
+        return endDate;
+    }
 
     /**
      * V metodě se přečte jeden záznam dat a rozřadí do určitých atributů - atributy bude možné dále využívat
+     * -issue #7319
      * @param dataRecord jeden záznam načtených dat
      */
     @Override
     public void proccesData(String[] dataRecord) {
-
+        for(int index = 0;index<=dataRecord.length;index++){
+            switch(index){
+                case numberLineIndex:
+                    this.numberLine = dataRecord[index];
+                    break;
+                case numberJoinIndex:
+                    this.numberJoin = dataRecord[index];
+                    break;
+                case numberTimeCodeIndex:
+                    this.numberTimeCode = dataRecord[index];
+                    break;
+                case timeCodeIndex:
+                    this.timeCode = dataRecord[index];
+                    break;
+                case typeTimeCodeIndex:
+                    this.typeTimeCode = dataRecord[index];
+                    break;
+                case startDateIndex:
+                    this.startDate = dataRecord[index];
+                    break;
+                case endDateIndex:
+                    this.endDate = dataRecord[index];
+                    break;
+            }
+        }
     }
 }
diff --git a/src/data/JDFLinkyRecord.java b/src/data/JDFLinkyRecord.java
deleted file mode 100644
index cce3ecd..0000000
--- a/src/data/JDFLinkyRecord.java
+++ /dev/null
@@ -1,24 +0,0 @@
-package data;
-
-/**
- *
- * Třída JDFLinkyRecord obsahuje jeden záznam načtených dat z Linky.txt
- *
- * @author Daniel Stus, Marek Sobota, Lukas Scurko, Jan Jirman
- * @version 1.0
- */
-
-public class JDFLinkyRecord implements IProcessable {
-
-    //-------------- Atributy --------------/
-    //TODO vytvořit proměnné pro všechna potřebná data
-
-    /**
-     * V metodě se přečte jeden záznam dat a rozřadí do určitých atributů - atributy bude možné dále využívat
-     * @param dataRecord jeden záznam načtených dat
-     */
-    @Override
-    public void proccesData(String[] dataRecord) {
-
-    }
-}
diff --git a/src/data/JDFPevnykodRecord.java b/src/data/JDFPevnykodRecord.java
index e860e2c..f4b7fce 100644
--- a/src/data/JDFPevnykodRecord.java
+++ b/src/data/JDFPevnykodRecord.java
@@ -3,6 +3,7 @@ package data;
 /**
  *
  * Třída JDFPevnykodyRecord obsahuje jeden záznam načtených dat
+ *-issue #7315
  *
  * @author Daniel Stus, Marek Sobota, Lukas Scurko, Jan Jirman
  * @version 1.0
@@ -49,7 +50,9 @@ public class JDFPevnykodRecord implements IProcessable{
 
     /**
      * V metodě se přečte jeden záznam dat a rozřadí do určitých atributů - atributy bude možné dále využívat
+     * -issue #7319
      * @param dataRecord jeden záznam načtených dat
+     *
      */
     @Override
     public void proccesData(String[] dataRecord) {
diff --git a/src/data/JDFSpojeRecord.java b/src/data/JDFSpojeRecord.java
new file mode 100644
index 0000000..2d95fee
--- /dev/null
+++ b/src/data/JDFSpojeRecord.java
@@ -0,0 +1,213 @@
+package data;
+
+/**
+ *
+ * Třída JDFSpojeRecord obsahuje jeden záznam načtených dat z Linky.txt
+ * -issue #7315
+ *
+ * @author Daniel Stus, Marek Sobota, Lukas Scurko, Jan Jirman
+ * @version 1.0
+ */
+
+public class JDFSpojeRecord implements IProcessable {
+
+    //-------------- Konstanty -------------//
+
+    /** konstanta indexu: numberLine */
+    private final int numberLineIndex = 0;
+    /** konstanta indexu: numberJoin */
+    private final int numberJoinIndex = 1;
+    /** konstanta indexu: hardCode1 */
+    private final int hardCodeIndex1 = 2;
+    /** konstanta indexu: hardCode2 */
+    private final int hardCodeIndex2 = 3;
+    /** konstanta indexu: hardCode3 */
+    private final int hardCodeIndex3 = 4;
+    /** konstanta indexu: hardCode4 */
+    private final int hardCodeIndex4 = 5;
+    /** konstanta indexu: hardCode5 */
+    private final int hardCodeIndex5 = 6;
+    /** konstanta indexu: hardCode6 */
+    private final int hardCodeIndex6 = 7;
+    /** konstanta indexu: hardCode7 */
+    private final int hardCodeIndex7 = 8;
+    /** konstanta indexu: hardCode8 */
+    private final int hardCodeIndex8 = 9;
+    /** konstanta indexu: hardCode9 */
+    private final int hardCodeIndex9 = 10;
+    /** konstanta indexu: hardCode10 */
+    private final int hardCodeIndex10 = 11;
+
+
+    //-------------- Atributy --------------/
+
+    private String numberLine;
+    private String numberJoin;
+    private String hardCode1;
+    private String hardCode2;
+    private String hardCode3;
+    private String hardCode4;
+    private String hardCode5;
+    private String hardCode6;
+    private String hardCode7;
+    private String hardCode8;
+    private String hardCode9;
+    private String hardCode10;
+
+    //------------ Konstruktor -------------/
+
+    /**
+     * Konstruktor JDFPevnykodRecord, který vytvoří jeden záznam z pevnychkodu v JDF
+     * @param dataRecord jeden záznam načtených dat
+     */
+    public JDFSpojeRecord(String[] dataRecord){
+        proccesData(dataRecord);
+    }
+
+    //------------- Metody -------------------/
+
+    /**
+     * Metoda vrátí cislo linky
+     * @return cislo linky
+     */
+    public String getNumberLine() {
+        return numberLine;
+    }
+
+    /**
+     * Metoda vrátí cislo spoje
+     * @return cislo spoje
+     */
+    public String getNumberJoin() {
+        return numberJoin;
+    }
+
+    /**
+     * Metoda vrátí cislo pevneho kodu
+     * @return cislo pevneho kodu
+     */
+    public String getHardCode1() {
+        return hardCode1;
+    }
+
+    /**
+     * Metoda vrátí cislo pevneho kodu
+     * @return cislo pevneho kodu
+     */
+    public String getHardCode2() {
+        return hardCode2;
+    }
+
+    /**
+     * Metoda vrátí cislo pevneho kodu
+     * @return cislo pevneho kodu
+     */
+    public String getHardCode3() {
+        return hardCode3;
+    }
+
+    /**
+     * Metoda vrátí cislo pevneho kodu
+     * @return cislo pevneho kodu
+     */
+    public String getHardCode4() {
+        return hardCode4;
+    }
+
+    /**
+     * Metoda vrátí cislo pevneho kodu
+     * @return cislo pevneho kodu
+     */
+    public String getHardCode5() {
+        return hardCode5;
+    }
+
+    /**
+     * Metoda vrátí cislo pevneho kodu
+     * @return cislo pevneho kodu
+     */
+    public String getHardCode6() {
+        return hardCode6;
+    }
+
+    /**
+     * Metoda vrátí cislo pevneho kodu
+     * @return cislo pevneho kodu
+     */
+    public String getHardCode7() {
+        return hardCode7;
+    }
+
+    /**
+     * Metoda vrátí cislo pevneho kodu
+     * @return cislo pevneho kodu
+     */
+    public String getHardCode8() {
+        return hardCode8;
+    }
+
+    /**
+     * Metoda vrátí cislo pevneho kodu
+     * @return cislo pevneho kodu
+     */
+    public String getHardCode9() {
+        return hardCode9;
+    }
+
+    /**
+     * Metoda vrátí cislo pevneho kodu
+     * @return cislo pevneho kodu
+     */
+    public String getHardCode10() {
+        return hardCode10;
+    }
+
+    /**
+     * V metodě se přečte jeden záznam dat a rozřadí do určitých atributů - atributy bude možné dále využívat
+     * -issue #7319
+     * @param dataRecord jeden záznam načtených dat
+     */
+    @Override
+    public void proccesData(String[] dataRecord) {
+        for(int index = 0;index<=dataRecord.length;index++){
+            switch(index){
+                case numberLineIndex:
+                    this.numberLine = dataRecord[index];
+                    break;
+                case numberJoinIndex:
+                    this.numberJoin = dataRecord[index];
+                    break;
+                case hardCodeIndex1:
+                    this.hardCode1 = dataRecord[index];
+                    break;
+                case hardCodeIndex2:
+                    this.hardCode2 = dataRecord[index];
+                    break;
+                case hardCodeIndex3:
+                    this.hardCode3 = dataRecord[index];
+                    break;
+                case hardCodeIndex4:
+                    this.hardCode4 = dataRecord[index];
+                    break;
+                case hardCodeIndex5:
+                    this.hardCode5 = dataRecord[index];
+                    break;
+                case hardCodeIndex6:
+                    this.hardCode6 = dataRecord[index];
+                    break;
+                case hardCodeIndex7:
+                    this.hardCode7 = dataRecord[index];
+                    break;
+                case hardCodeIndex8:
+                    this.hardCode8 = dataRecord[index];
+                    break;
+                case hardCodeIndex9:
+                    this.hardCode9 = dataRecord[index];
+                    break;
+                case hardCodeIndex10:
+                    this.hardCode10 = dataRecord[index];
+                    break;
+            }
+        }
+    }
+}