commit 10cf0fff69c1d8aafb7b2bbbf1b07f37e006a4bf
Author: castic96 <zdenek.castoral.jr@gmail.com>
Date:   Fri Apr 3 20:00:12 2020 +0200

    #7724: Implementace architektury FE
    - vylepšení stylů

diff --git a/fe/fulltextsearch/src/app/components/pages/home/home.component.css b/fe/fulltextsearch/src/app/components/pages/home/home.component.css
index 2959939..12c8182 100644
--- a/fe/fulltextsearch/src/app/components/pages/home/home.component.css
+++ b/fe/fulltextsearch/src/app/components/pages/home/home.component.css
@@ -1,4 +1,4 @@
-div {
+.background {
   background: url("../../../../assets/img/index_background.jpg") no-repeat center center fixed;
   -webkit-background-size: cover;
   -moz-background-size: cover;
@@ -10,3 +10,11 @@ div {
   top: 0;
   left: 0;
 }
+
+.container {
+  height: 100%;
+}
+
+.row {
+  height: 100%;
+}
diff --git a/fe/fulltextsearch/src/app/components/pages/home/home.component.html b/fe/fulltextsearch/src/app/components/pages/home/home.component.html
index 2489979..6c79945 100644
--- a/fe/fulltextsearch/src/app/components/pages/home/home.component.html
+++ b/fe/fulltextsearch/src/app/components/pages/home/home.component.html
@@ -1,5 +1,7 @@
-<div>
-  <app-search-box></app-search-box>
+<div class="background">
+  <div class="container">
+    <div class="row justify-content-center align-items-center">
+      <app-search-box class="col-sm-10 col-md-8 col-lg-6"></app-search-box>
+    </div>
+  </div>
 </div>
-
-
diff --git a/fe/fulltextsearch/src/app/components/shared-components/search-box/search-box.component.css b/fe/fulltextsearch/src/app/components/shared-components/search-box/search-box.component.css
index a1d73fa..4c284e0 100644
--- a/fe/fulltextsearch/src/app/components/shared-components/search-box/search-box.component.css
+++ b/fe/fulltextsearch/src/app/components/shared-components/search-box/search-box.component.css
@@ -16,9 +16,14 @@ button:hover {
   background-color: var(--search-background-color);
   color: grey;
   border-style: none;
+  border-radius: 0;
 }
 
 .form-control {
   height: 35pt;
   border-style: none;
 }
+
+input:focus {
+  box-shadow: none;
+}
diff --git a/fe/fulltextsearch/src/app/components/shared-components/search-box/search-box.component.html b/fe/fulltextsearch/src/app/components/shared-components/search-box/search-box.component.html
index d76285c..a4a4fdd 100644
--- a/fe/fulltextsearch/src/app/components/shared-components/search-box/search-box.component.html
+++ b/fe/fulltextsearch/src/app/components/shared-components/search-box/search-box.component.html
@@ -1,21 +1,16 @@
-<div class="container">
-
-  <div class="row justify-content-center align-items-center" style="height: 500px">
-
-    <div class="col-sm-10 col-md-8 col-lg-6">
-      <div class="input-group mb-3">
-        <div class="input-group-prepend">
+<div>
+  <div class="input-group mb-3">
+    <div class="input-group-prepend">
+  <span class="input-group-text">
+    <mat-icon>search</mat-icon>
+  </span>
+    </div>
+    <input type="text" class="form-control" [(ngModel)]="expression" placeholder="Enter text to search..." aria-label="Search" aria-describedby="basic-addon2">
+    <div class="input-group-append">
       <span class="input-group-text">
-        <mat-icon>search</mat-icon>
+        <mat-icon *ngIf="expression" matSuffix aria-label="Clear" (click)="expression=''">clear</mat-icon>
       </span>
-        </div>
-        <input type="text" class="form-control" [(ngModel)]="expression" placeholder="Enter text to search..." aria-label="Search" aria-describedby="basic-addon2">
-        <div class="input-group-append">
-          <button class="btn btn-outline-secondary" type="button" (click)="onSubmit()">Search</button>
-        </div>
-      </div>
+      <button class="btn btn-outline-secondary" type="button" (click)="onSubmit()">Search</button>
     </div>
-
   </div>
-
 </div>
diff --git a/fe/fulltextsearch/src/app/components/shared-components/search-box/search-box.component.ts b/fe/fulltextsearch/src/app/components/shared-components/search-box/search-box.component.ts
index af6ab99..de4448e 100644
--- a/fe/fulltextsearch/src/app/components/shared-components/search-box/search-box.component.ts
+++ b/fe/fulltextsearch/src/app/components/shared-components/search-box/search-box.component.ts
@@ -9,7 +9,8 @@ import { Router } from '@angular/router';
   styleUrls: ['./search-box.component.css']
 })
 export class SearchBoxComponent implements OnInit {
-  expression: string
+  expression: string;
+
 
   constructor(private queryService: QueryService, private router: Router) { }
 
@@ -23,9 +24,9 @@ export class SearchBoxComponent implements OnInit {
     /*
     this.queryService.searchPost(searchRequest).subscribe (() => {
       //TODO: ulozit objekt SearchResponse[]
+
       this.router.navigate(['/search']);
     });
     */
   }
-
 }